#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	 
	counter = 0;
	ofBackground(255,255,255);	
}

//--------------------------------------------------------------
void testApp::update(){
	counter = counter + 0.033f;
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetupScreen();

	
	ofFill();		// draw "filled shapes"
	
	//---------------------------
	//let's draw a circle:
	ofSetColor(255,130,0);
	float radius = 50 + 10 * sin(counter);
	ofCircle(100,400,radius);
	
	// circles are "pre-cached" - if you 
	// want, you can alter the resolution
	// for more or less points.
	// take a look in ofGraphics.h
	
	//---------------------------
	// use the bitMap type
	// note, this can be slow on some graphics cards
	// because it is using glDrawPixels which varies in
	// speed from system to system.  try using ofTrueTypeFont
	// if this bitMap type slows you down.
	ofSetColor(0x000000);
	ofDrawBitmapString("a test of bitmap type", 100,400);
	
	//---------------------------
	// draw a rectangle
	ofSetColor(130,255,0);
	ofRect(500,300,100,100);
	
	//---------------------------
	// alpha is usually turned off - for speed puposes.  let's turn it on!
	ofEnableAlphaBlending();	
	ofSetColor(255,0,0,127);   // red, 50% transparent
	ofRect(550,350,100,33);
	ofSetColor(255,0,0,(int)(counter * 10.0f) % 255);   // red, variable transparent
	ofRect(550,300,100,33);
	ofDisableAlphaBlending();	

	//---------------------------
	// now just draw outlines
	ofNoFill();		
	ofSetColor(0xCCCCCC);
	ofCircle(300,200,100);
	
	//---------------------------
	// a bunch of red lines
	ofSetColor(0xFF0000);
	for (int i = 0; i < 20; i++){
		ofLine(300,200,500, 200 + i * 10);
	}
	
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
