#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	 
	
	vidGrabber.setVerbose(true);
	vidGrabber.setShowDialog(true);
	vidGrabber.initGrabber(320,240);
	
	videoInverted 	= new unsigned char[320*240*3];
	videoTexture.allocate(320,240, GL_RGB);
	
}


//--------------------------------------------------------------
void testApp::update(){
	ofBackground(100,100,100);
	
	vidGrabber.grabFrame();
	
	if (vidGrabber.isFrameNew()){
		int totalPixels = 320*240*3;
		unsigned char * pixels = vidGrabber.getPixels();
		for (int i = 0; i < totalPixels; i++){
			videoInverted[i] = 255 - pixels[i];
		}
		videoTexture.loadData(videoInverted, 320,240, GL_RGB);
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetupScreen();

	ofSetColor(0xffffff);
	vidGrabber.draw(20,20);
	videoTexture.draw(360,20,320,240);
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	// in fullscreen mode, on a pc at least, the 
	// first time video settings the come up
	// they come up *under* the fullscreen window
	// use alt-tab to navigate to the settings
	// window. we are working on a fix for this...
	
	if (key == 's' || key == 'S'){
		vidGrabber.videoSettings();
	}
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
