
void display(void);
void mouse_cb(int button, int state, int x, int y);
void motion_cb(int x, int y);
void passive_motion_cb(int x, int y);
void idle_cb(void);
void keyboard_cb(unsigned char key, int x, int y);
void special_key_cb(int key, int x, int y) ;
static int buttonInUse = 0;

//-------------------------------- 
static float timeNow, timeThen, fps;
static int nFrames;

//------------------------------------------------------------
void display(void){	
	
	//-------------------------------- 
	// when I had "glutFullScreen()"
	// in the initOpenGl, I was gettings a "heap" allocation error 
	// when debugging via visual studio.  putting it here, changes that.
	// maybe it's voodoo, or I am getting rid of the problem 
	// by removing something unrelated, but everything seems
	// to work if I put fullscreen on the first frame of display.

	if (nFrames == 0 && windowMode == OF_FULLSCREEN) glutFullScreen();

	ofGetWindowSize( &width, &height );        
	height = height > 0 ? height : 1;
	// set viewport, clear the screen
	glViewport( 0, 0, width, height );
	float * bgPtr = ofBgColorPtr();
	glClearColor(bgPtr[0],bgPtr[1],bgPtr[2], bgPtr[3]);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	ofSetupScreen();
	OFSAptr->draw();
  	glutSwapBuffers();
  	
  	// -------------- fps calculation:
	timeNow = ofGetElapsedTimef();
	if( (timeNow-timeThen) > 0.05f || nFrames == 0 ) {
 		fps = (double)nFrames / (timeNow-timeThen);
      	timeThen = timeNow;
		nFrames = 0;
		ofFrameRate = 0.9f * ofFrameRate + 0.1f * fps;
  	}
  	nFrames++;
  	// --------------
}
//------------------------------------------------------------
void mouse_cb(int button, int state, int x, int y) {
  if (state == GLUT_DOWN) {
    OFSAptr->mousePressed(x, height - y, button);
  } else if (state == GLUT_UP) {
    OFSAptr->mouseReleased();
  }
  buttonInUse = button;
}

//------------------------------------------------------------
void motion_cb(int x, int y) {
	OFSAptr->mouseDragged(x, height - y, buttonInUse);
}

//------------------------------------------------------------
void passive_motion_cb(int x, int y) {
	OFSAptr->mouseMoved(x, height - y);
}

//------------------------------------------------------------
void idle_cb(void) {
	OFSAptr->update();
	glutPostRedisplay();
}

//------------------------------------------------------------
void keyboard_cb(unsigned char key, int x, int y) {
	OFSAptr->keyPressed((int)key);
	if (key == 27){				// "escape"
		 OF_EXIT_APP(0);
	}
}

//------------------------------------------------------------
void special_key_cb(int key, int x, int y) {
   OFSAptr->keyPressed((int)key);
}
