#include "ofAppRunner.h"

//========================================================================
// static variables:
static ofSimpleApp * 		OFSAptr;
int							windowMode;
bool 						bMousePressed;
bool						bRightButton;
int							width, height;
static float 				ofFrameRate;
//========================================================================
// callbacks:
#include "ofAppGlutGlue.h"	


//--------------------------------------
void ofSetupOpenGL(int w, int h, int screenMode){
	int argc = 1;
	char *argv = "openframeworks";
	char **vptr = &argv;
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH | GLUT_ALPHA);
	glutInit(&argc, vptr);
	//if (screenMode == OF_WINDOW)		
	glutInitWindowSize(w, h);
	glutCreateWindow("");
	windowMode = screenMode;
	

	ofBackground(200,200,200);		// default bg color
	ofSetColor(0xFFFFFF); 			// default draw color
									// used to be black, but 
									// black + texture = black
									// so maybe grey bg
									// and "white" fg color
									// as default works the best...
									
}


//--------------------------------------
void ofRunApp(ofSimpleApp * OFSA){
	
	OFSAptr = OFSA;
	
	//----------------------
	// setup the callbacks 
	glutMouseFunc(mouse_cb);
	glutMotionFunc(motion_cb);
	glutPassiveMotionFunc(passive_motion_cb);
	glutIdleFunc(idle_cb);
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard_cb);
	glutSpecialFunc(special_key_cb);
	//----------------------
	
	OFSA->setup();
	glutMainLoop();
}

//--------------------------------------
float ofGetFrameRate(){
	return ofFrameRate;
}	

//--------------------------------------
void ofHideCursor(){
	glutSetCursor(GLUT_CURSOR_NONE);
}

//--------------------------------------
void ofShowCursor(){
	glutSetCursor(GLUT_CURSOR_RIGHT_ARROW);
}
