#include "ofUtils.h"





//--------------------------------------------------
int ofNextPow2 ( int a ){
	// from nehe.gamedev.net lesson 43
	int rval=1;
	while(rval<a) rval<<=1;
	return rval;
}

//--------------------------------------------------
void ofGetWindowSize( int  * w, int *  h){
	*w = glutGet(GLUT_WINDOW_WIDTH);	
	*h = glutGet(GLUT_WINDOW_HEIGHT);	
}

//--------------------------------------------------
int 	ofGetWidth(){
	return glutGet(GLUT_WINDOW_WIDTH);
}
//--------------------------------------------------
int 	ofGetHeight(){
	return glutGet(GLUT_WINDOW_HEIGHT);
}


static int frameNum = 0;

// whole frame:
//--------------------------------------------------
void ofScreenCapRaw(){

	int w, h;
	ofGetWindowSize( &w, &h );
	char *ScreenImageBuffer = (char*)malloc(w*h*3);
	char *flippedScreenImageBuffer = (char*)malloc(w*h*3);
	char fileName [255];
	sprintf(fileName, "screen_grab__%ix%i__%0.4i.raw", w, h, frameNum++);
	FILE* OutputFile = fopen(fileName, "wb");
	glReadPixels(0,0,w,h,GL_RGB,GL_UNSIGNED_BYTE,ScreenImageBuffer);
	// need to flip image
	for (int i = 0; i < h; i++) {
		memcpy(flippedScreenImageBuffer+(sizeof(char)*i*w*3), ScreenImageBuffer+(sizeof(char)*(h-i)*w*3), sizeof(char)*w*3);
	}
	fwrite(flippedScreenImageBuffer,w*h*3,1,OutputFile);
	fclose(OutputFile);
	free(ScreenImageBuffer);
	free(flippedScreenImageBuffer);

}


// sub region of frame:
//--------------------------------------------------
void ofScreenCapRaw(int x, int y, int w, int h){
	
	int width = w;  // width of cap region
	int height = h;  // height of cap region
	int sw, sh;
	// bounds checking here -----
	ofGetWindowSize( &sw, &sh );
	if (width+x > sw) width = sw-x;
	if (height+y > sh) height = sh-y;

	char *ScreenImageBuffer = (char*)malloc(width*height*3);
	char *flippedScreenImageBuffer = (char*)malloc(width*height*3);
	char fileName[255];
	sprintf(fileName, "screen_grab__%ix%i__%0.4i.raw", width, height, frameNum++);
	FILE* OutputFile = fopen(fileName, "wb");
	glReadPixels(x,y,width,height,GL_RGB,GL_UNSIGNED_BYTE,ScreenImageBuffer);
	// need to flip image
	for (int i = 0; i < height; i++) {
		memcpy(flippedScreenImageBuffer+(sizeof(char)*i*width*3), ScreenImageBuffer+(sizeof(char)*(height-i)*width*3), sizeof(char)*width*3);
	}
	fwrite(flippedScreenImageBuffer,width*height*3,1,OutputFile);
	fclose(OutputFile);
	free(ScreenImageBuffer);
	free(flippedScreenImageBuffer);

}

//--------------------------------------
int ofGetElapsedTimeMillis(){
	return (int)(glutGet(GLUT_ELAPSED_TIME));
}

//--------------------------------------
float ofGetElapsedTimef(){
	return (float)(glutGet(GLUT_ELAPSED_TIME))/1000.0f;
}

//--------------------------------------
int ofGetMillis(){
	//  this is a hack now...  should be based on system time
	// 	time_t is not in millisecond resolution.  what to replace this with?
	// 	for not millis is elapsed milliseconds, not clock millis...
    return (int)(glutGet(GLUT_ELAPSED_TIME) % 1000);
	//	http://man.he.net/man2/gettimeofday
}

//--------------------------------------------------
int ofGetSeconds(){
	time_t 	curr;
	tm 		local;
	time(&curr);
	local	=*(localtime(&curr)); 
	return local.tm_sec; 
}

//--------------------------------------------------
int ofGetMinutes(){
	time_t 	curr;
	tm 		local;
	time(&curr);
	local	=*(localtime(&curr)); 
	return local.tm_min; 
}

//--------------------------------------------------
int ofGetHours(){
	time_t 	curr;
	tm 		local;
	time(&curr);
	local	=*(localtime(&curr)); 
	return local.tm_hour; 
}




