#include "ofQtUtils.h"


static bool bQuicktimeInitialized = true;

//----------------------------------------
void initializeQuicktime(){	
	if (bQuicktimeInitialized == true){	
		
		//----------------------------------
		// do we have quicktime installed at all?
		// http://www.apple.com/quicktime/download/win.html
		// can gestalt help with versions, or is that only after init?
		
		long			myAttrs;
		OSErr myErr 	= noErr;
		#ifdef TARGET_WIN32
			myErr = InitializeQTML(0);
			if (myErr != noErr){
				printf("----------------------------------------------------- \n");
				printf("sorry, there is a problem with quicktime starting up \nplease check!");
                // std exit has trouble on dev-c++
				OF_EXIT_APP(0);
			}
		#endif
		myErr = EnterMovies ();
		if (myErr != noErr){
			printf("----------------------------------------------------- \n");
			printf("sorry, there is a problem with quicktime starting up  \nplease check!");
			OF_EXIT_APP(0);
		}

		bQuicktimeInitialized = false;
	}
}



//----------------------------------------
void convertPixels(unsigned char * gWorldPixels, unsigned char * rgbPixels, int w, int h){
	
	// ok for macs?
	// ok for intel macs?
	
	int * rgbaPtr 			= (int *) gWorldPixels;
	pix24 * rgbPtr 			= (pix24 *) rgbPixels;
	int totalPixelCount 	= w * h;
	unsigned char * rgbaStart;
	bool bFlipVertically 	= true;
	
	// -------------------------------------------
	// we flip vertically because the 0,0 position in OF 
	// is the bottom left (not top left, like processing)
	// since the 0,0 of a picture is top left
	// if we upload and draw the data as is
	// it will be upside-down....
	// -------------------------------------------
	
	if (!bFlipVertically){
		//----- argb->rgb
		for (int i = 0; i < totalPixelCount; i++){
			rgbaStart = (unsigned char *)rgbaPtr;	
			memcpy (rgbPtr, rgbaStart+1, sizeof(pix24));
			rgbPtr++;
			rgbaPtr++;
		}
	} else {
		//----- flip while argb->rgb
		for (int i = 0; i < h; i++){
			pix24 * rgbPtr 			= (pix24 *) rgbPixels + ((h-i-1) * w);
			for (int j = 0; j < w; j++){
				rgbaStart = (unsigned char *)rgbaPtr;	
				memcpy (rgbPtr, rgbaStart+1, sizeof(pix24));
				rgbPtr++;
				rgbaPtr++;
			}
		}
	}
}
